## net.sf.saxon.functions
Class ResolveURI

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.FunctionCall
              net.sf.saxon.functions.SystemFunction
                  net.sf.saxon.functions.ResolveURI

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, EvaluableItem, SequenceIterable, InstructionInfo, Locator

    public class ResolveURI

extends SystemFunction

This class supports the resolve-uri() functions in XPath 2.0

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.functions.SystemFunction
`operation`

Fields inherited from class net.sf.saxon.expr.FunctionCall
`argument`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, PUSH_SELECTION, staticProperties, WATCH_METHOD`

Constructor Summary
`ResolveURI()`

Method Summary
`void` `checkArguments(ExpressionVisitor visitor)` Method called during static type checking
`Expression` `copy()` Copy an expression.
`static String` `escapeSpaces(String s)` Replace spaces by %20
`Item` `evaluateItem(XPathContext context)` Evaluate the function at run-time
`String` `getStaticBaseURI()` Get the static base URI of the expression
`static URI` `makeAbsolute(String relativeURI, String base)` Construct an absolute URI from a relative URI and a base URI.
`static String` `tryToExpand(String systemId)` If a system ID can't be parsed as a URL, try to expand it as a relative URI using the current directory as the base URI.

Methods inherited from class net.sf.saxon.functions.SystemFunction
`addContextDocumentArgument, addDocToPathMap, computeCardinality, computeSpecialProperties, getDetails, getErrorCodeForTypeErrors, getImplementationMethod, getItemType, getRequiredType, makeSystemFunction, optimize, setDetails, useContextItemAsDefault`

Methods inherited from class net.sf.saxon.expr.FunctionCall
`addExternalFunctionCallToPathMap, checkArgumentCount, equals, explain, getArguments, getDisplayName, getExpressionName, getFunctionName, getNumberOfArguments, hashCode, iterateSubExpressions, preEvaluate, promote, replaceSubExpression, setArguments, setFunctionName, simplify, simplifyArguments, toString, typeCheck`

Methods inherited from class net.sf.saxon.expr.Expression

`addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterate, iterateEvents, iterateSameFocusSubExpressions, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ResolveURI

    public ResolveURI()

Method Detail

### checkArguments

    public void checkArguments(ExpressionVisitor visitor)
                        throws XPathException

  Description copied from class: `SystemFunction`
  Method called during static type checking

  Overrides:
    `checkArguments` in class `SystemFunction`
  Parameters:
    `visitor` - the expression visitor
  Throws:
    `XPathException`

### getStaticBaseURI

    public String getStaticBaseURI()

  Get the static base URI of the expression

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Overrides:
    `copy` in class `SystemFunction`
  Returns:
    the copy of the original expression

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate the function at run-time

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### tryToExpand

    public static String tryToExpand(String systemId)

  If a system ID can't be parsed as a URL, try to expand it as a relative URI using the current directory as the base URI.

### makeAbsolute

    public static URI makeAbsolute(String relativeURI,
                                   String base)
                            throws URISyntaxException

  Construct an absolute URI from a relative URI and a base URI. The method uses the resolve method of the java.net.URI class, except where the base URI uses the (non-standard) "jar:" scheme, in which case the method used is `new URL(baseURL, relativeURL)`.

  Spaces in either URI are converted to %20

  If no base URI is available, and the relative URI is not an absolute URI, then the current directory is used as a base URI.

  Parameters:
    `relativeURI` - the relative URI. Null is permitted provided that the base URI is an absolute URI
    `base` - the base URI. Null is permitted provided that relativeURI is an absolute URI
  Returns:
    the absolutized URI
  Throws:
    `URISyntaxException` - if either of the strings is not a valid URI or if the resolution fails

### escapeSpaces

    public static String escapeSpaces(String s)

  Replace spaces by %20

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.